<?php /* $Id: send.inc,v 1.7.2.1 2006/12/17 02:03:17 vauxia Exp $ */

function _send_nodetype_settings(&$form, $type) {
  $modules = _send_modules();
  
  /* We don't want to junk up the variable namespace with our module settings 
     since we're relying on our own cascading variable storage.
     Import the variables into our storage handler and then delete them
  */
  global $conf;
  $keep = array('linktext', 'pernode');  // variables to keep in $conf
  foreach ($modules as $m) {
    $namespace = "{$m}_{$type}_";
    foreach ($conf as $name=>$value) {
      if (substr($name,0,strlen($namespace)) == $namespace) {
        $varname = str_replace($namespace, '', $name);
        _send_value($varname, $m, $type, null, $value);
        if (!in_array($varname, $keep)) variable_del($name);
      }
    }
  }
  
  $form['send'] = array( '#weight' => 5 );
    
  // goofy hack to get the buttons at the end of the array :(
  $form['buttons']['#weight'] = 9;
      
  foreach($modules as $m) {
    $module_name = module_invoke($m, 'send', 'name', $m);
    $form['send'][$m] =  _send_settings_form($m, $type);
    
    // enable this send type
    $form['send'][$m]["{$m}_{$type}"] = array(
      '#type'          => 'checkbox',
      '#weight'        => -10,
      '#title'         => t('Enable "%name" functionality', array('%name' => $module_name)),
      '#default_value' => variable_get("{$m}_{$type}",0),
    );
    
    // allow per-node overrides
    $form['send'][$m]["{$m}_{$type}_pernode"] = array(
      '#type'          => 'checkbox',
      '#weight'        => -9,
      '#title'         => t('Permit changes on every item'),
      '#default_value' => _send_value('pernode', $m, $type),
    );
    
    $form['send'][$m]['#title'] = $module_name;
    $form['send'][$m]['#type'] = 'fieldset';
    if (count($modules) > 1 ) {
      $form['send'][$m]['#collapsible'] = true;
      $form['send'][$m]['#collapsed']   = true;
    }
  }
  return $form;
}

function _send_node_form(&$form, $nodetype) {
  $form['send'] = array();
  foreach (_send_modules() as $m) {
    if (!variable_get("{$m}_{$nodetype}", 0)) continue;
    if (!variable_get("{$m}_{$nodetype}_pernode", 0)) continue;
    
    $form['send'][$m] = _send_settings_form($m, $nodetype, $form['#node']);
    $form['send'][$m]['#title'] = module_invoke($m, 'send', 'name', $m);
    $form['send'][$m]['#type'] = 'fieldset';
    $form['send'][$m]['#collapsible'] = true;
    $form['send'][$m]['#collapsed']   = true;
  }
  return $form;
}

function _send_settings_form($module, $nodetype='', $node=null) {
  $type = $nodetype ? "_$nodetype" : "";
  
  $form["{$module}{$type}_fulltext"] = array (
    '#type'          => 'checkbox',
    '#title'         => t('Allow visitors to send full item text'),
    '#default_value' => _send_value('fulltext', $module, $nodetype, $node),
  );
  $form["{$module}{$type}_linktext"] = array(
    '#type'          => 'textfield',
    '#title'         => t("Link text"),
    '#default_value' => _send_value('linktext', $module, $nodetype, $node),
    '#size'          => 30,
    '#maxsize'       => 100,
    '#description'   => t('Leave blank to suppress link'),
  );
  $form["{$module}{$type}_subject"] = array(
    '#type'          => 'textfield',
    '#title'         => t("E-mail subject line"),
    '#default_value' => _send_value('subject', $module, $nodetype, $node),
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form["{$module}{$type}_message"] = array(
    '#type'          => 'textarea',
    '#title'         => t("Default message text"),
    '#default_value' => _send_value('message', $module, $nodetype, $node),
    '#cols'          => 70,
    '#rows'          => 10,
  );
  $form["{$module}{$type}_template"] = array (
    '#type'          => 'textarea',
    '#title'         => t('Email Template'),
    '#default_value' => _send_value('template', $module, $nodetype, $node),
    '#rows'          => 30,
    '#cols'          => 70,
  );
  if ($module_settings = module_invoke($module,'send', 'settings', $module)) {
    $form = array_merge($form, $module_settings);
  }
  return $form;
}

/**
 * function for hook_settings().
 */
function _send_admin($module='default') {
  $form = _send_settings_form($module);
  $form["{$module}_threshold"] = array (
    '#type'          => 'textfield',
    '#title'         => t('Send Threshold'),
    '#description'   => t('The maximum number of times per hour a user can send a message.  0 for unlimited'),
    '#default_value' => _send_value('threshold', $module),
    '#size'          => 3,
    '#maxlength'     => 3,
    '#weight'        => -9,
  );
  
  $form['module'] = array('#type'=>'value', '#value'=>$module);
  $form['submit'] = array('#type'=>'submit', '#value'=>t('Save configuration'));
  
  return drupal_get_form('_send_admin', $form);
}

function _send_admin_submit($form_id, $values) {
  $module = $values['module'];
  $modname = $module == 'default' ? '' : $module;
  foreach($values as $key => $value) {
    $name = str_replace("{$module}_", '', $key);
    if ($name != $key) {
      _send_value($name, $modname, '', '', $value);
    }
  }
}

function _send_node_save(&$node) {
  foreach(_send_modules() as $m) {
    if (!variable_get("{$m}_{$node->type}_pernode", 0)) continue;
    
    foreach ($node as $key => $value) {
      $name = str_replace("{$m}_{$node->type}_", '', $key);
      if ($name != $key) {
        _send_value($name, $m, $node->type, $node, $value);
      }
    }
  }
}

function _send_page($module='send', $nids=array(), $mode='teaser') {
  
  drupal_set_title(module_invoke($module, 'send', 'name', $module));
  
  // node id's from url path
  if($nids && !is_array($nids)) {
    $nids = is_numeric($nids) ? array($nids) : explode(' ', $nids);
  }
  if (!count($nids)) {
    return module_invoke($module, 'send', 'default action', $module);
  }
 
  // basic security checks
  foreach($nids as $n) {
    if (!is_numeric($n) || !node_access('view', $node = node_load($n))) { 
      drupal_set_message(t('There was a problem loading this item'),'error');
      drupal_goto();
    }
    elseif (!variable_get("{$module}_{$node->type}",0)) {
      drupal_set_message(t('Unable to send this item'),'error');
      drupal_goto();
    }
  }
  
  // check against threshold
  $threshold = _send_value('threshold', $module);
  if ($threshold && !flood_is_allowed("send $module", $threshold)) {
    drupal_set_message(t('You have exceeded the limit for sending items'), 'error');
    drupal_goto();
  }
  
  $form = _send_form($module, $nids);
  return drupal_get_form($module, $form, '_send');
}

function _send_form($module, $nids=array()) {
  
  if ($form = module_invoke($module, 'send', 'form', $module)) {
    return $form;
  }
  
  global $user;
  
  $sender = array('first_name' => '', 'last_name'=> '');
  _send_crm_contact($user->mail, $sender);
  
  $mode = 'teaser';
  $node = count($nids) ? node_load($nids[0]) : null;
  $type = $node->type;

  if (count($nids) == 1) {
    if (_send_value('fulltext', $module, $type, $node)) $mode = 'body';
  }
  
  // recipient(s), from history if it's available
  $previous = _send_previous_recipients($user);
  
  $form = array(
    '#theme'         => 'send_form',
  ); 
  $form['from'] = array();
  $form['from']['sender_mail'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Email'),
    '#default_value' => $user->mail,
    '#required'      => true,
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form['from']['sender_first_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t('First Name'),
    '#default_value' => $sender['first_name'],
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form['from']['sender_last_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Last Name'),
    '#default_value' => $sender['last_name'],
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form['from']['sender_cc'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Send a copy to myself'),
    '#default_value' => 0,
  );
  $form['to'] = array();
  $form['to']['recipient_mail'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Email'),
    '#required'      => true,
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form['to']['recipient_first_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t('First Name'),
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  $form['to']['recipient_last_name'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Last Name'),
    '#size'          => 30,
    '#maxsize'       => 100,
  );
  
  $subject = _send_value('subject', $module, $type, $node);
  $form['subject'] = array();
  $form['subject']['subject_view'] = array(
    '#type'          => 'markup',
    '#value'         => $subject,
  );
  $form['subject']['subject'] = array(
    '#type'          => 'value',
    '#title'         => t('E-mail Subject Line'),
    '#value'         => $subject,
  );
  
  $template = _send_value('template', $module, $type, $node);
  $form['template'] = array();
  $form['template']['template_view'] = array(
    '#type' => 'markup', '#value' => $template,
  );
  $form['template']['template'] = array(
    '#type' => 'value', '#value' => $template,
  );
  
  $body = _send_body('', $nids, $module, $mode);
  $message = _send_value('message', $module, $type, $node);
  $form['message'] = array();
  $form['message']['message'] = array(
    '#type'          => 'textarea',
    '#title'         => t('Message Text'),
    '#cols'          => 70,
    '#rows'          => $body ? 10 : 30,  // longer if no body
    '#default_value' => $message,
  );
  
  $form['body'] = array();
  $form['body']['node_body_view'] = array(
    '#type'          => 'markup',
    '#value'         => $body,
  );
  $form['body']['node_body'] = array(
    '#type'          => 'value',
    '#value'         => $body,
    '#cols'          => 70,
    '#rows'          => 30,
  );
  
  $form['extra']['nids']   = array( '#type' => 'value', '#value' => $nids);
  $form['extra']['mode']   = array( '#type' => 'value', '#value' => $mode, );
  $form['extra']['module'] = array( '#type' => 'value', '#value' => $module, );
  
  $form['buttons'] = array();
  $form['buttons']['submit'] = array(
    '#type' => 'submit', '#value' => t('Send'),
  );
  return $form;
}

function _send_validate($form_id, $values) {
  $ret = true;
  if (!valid_email_address($values['sender_mail'])) {
    form_set_error('sender_mail',t('Invalid from address'));
    $ret = false;
  }
    
  if(isset($values['recipient_mail']) && !valid_email_address($values['recipient_mail'])) {
    form_set_error('recipient_mail',t('Invalid recipient address'));
    $ret = false;
  }
  return $ret;
}

function _send_submit($form_id, $values) {
  global $user;
    
  $sid     = db_next_id("{send}_sid");
  $module  = $values['module'];
  $uid     = $user->uid;
  $mail    = $values['sender_mail'];
  $message = $values['message'];
  $subject = $values['subject'];
  $first_name = $values['sender_first_name'];
  $last_name  = $values['sender_last_name'];
  ($name = trim($first_name.' '.$last_name)) || ($name = $values['sender_name']);
  
  $values['sid'] = $sid;  // in case a module needs it
  
  // log send action
  db_query("INSERT INTO {send} 
    ( sid ,module ,uid ,mail ,timestamp ,message, subject, name ) 
    VALUES ( %d ,'%s' ,%d ,'%s' ,%d ,'%s', '%s', '%s')"
    , $sid, $module, $uid, $mail, time(), $message, $subject, $name);
  
  // log a CRM activity
  if ($contact = _send_crm_contact($mail, $values, $user, 'sender')) {
    $activity = array(
      'entity_table'    => 'civicrm_contact',
      'entity_id'       => $contact->id,
      'module'          => 'send',
      'activity_type'   => t('Sent %subject',array('%subject' => $subject)),
      'activity_date'   => date('YmdHis',time()),
      'activity_id'     => $sid,
    );
    crm_create_activity_history($activity);
  }
  
  // create a $sender array for delivery functions
  $sender = array('mail' => $mail, 'name' => $name);
  if (!$sender['name']) $sender['name'] = $user->name;
  
  // fetch a themed body
  if (!$body = theme("{$module}_body", $values)) {
    $body = theme('send_body', $values);
  }
  
  // get delivery callback
  if(!$deliver = module_invoke($module, 'send', 'deliver', $module)) {
    $deliver = module_invoke('send', 'send', 'deliver','send');
  }
  
  $recipients = array();
  // recipients are from a space/line-delimited textarea
  if (isset($values['recipients'])) {
    if (!is_array($recipients = $values['recipients'])) {
      $recipients = array();
      foreach (explode(',', preg_replace(array("/\s/ms","/,+/"), ',',$values['recipients'])) as $r) {
        if (valid_email_address($r)) {
          $recipients[] = array('mail' => $r);
        }
        else {
          $recipients[] = $r;
        }
      }
    }
  }
  
  // recipients expanded into separate form fields
  // e.g. recipient1_first_name, recipient2_mail,  and so-on
  if(!count($recipients)) {
    foreach ($values as $key => $value) {
      if ($key != ($name = preg_replace('/^recipient(\d*)_/', '\1 ', $key))) {
        list($i, $name) = explode(' ', $name);
        if (!$i) $i = 1;
        $i--;
        if (!isset($recipients[$i])) $recipients[$i] = array();
        $recipients[$i][$name] = $value;
      }
    }
  }

  // recipient type - for now, 'node' or 'user'
  ($rtype = module_invoke($module, 'send', 'recipient type', $module))
    || ($rtype = module_invoke('send', 'send', 'recipient type', $module));
  
  $ret = true;
  foreach ($recipients as $r) {
    $rid = 0;

    switch ($rtype) {
      case 'user':
        // try to log message as a crm activity for recipient
        if (is_array($r) && isset($r['mail'])) {
          $recipient_user = user_load(array('mail'=>$r['mail']));
          if ($contact = _send_crm_contact($r['mail'], $r, $recipient_user)) {
            crm_create_activity_history($arr = array_merge($activity, array(
              'entity_id' => $contact->id, 
              'activity_type' => t('Received %subject', array('%subject' => $subject)),
            )));
          }
          $rid = $recipient_user->uid;
      
          if (!$r['name']) {
            $r['name'] = trim($r['first_name'].' '.$r['last_name']);
            if (!$r['name']) $r['name'] = $recipient_user->name;
          }
          $r_name = $r['name'];
          $r_mail = $r['mail'];
        }
        break;
      case 'node':
        // when the type is "node" each recipient is a nid
        $rid    = $r;
        $r      = node_load($rid);
        $r_name = $r->title;
        $r_mail = '';
        break;
    }
      
    // add querystrings to urls in the message body
    $qs = array();
    foreach (_send_modules() as $m) {
      if($callback = module_invoke($m, 'send', 'querystring', $module)) {
        $qs = array_merge($qs, call_user_func($callback, $sender, $r, $values));
      }
    }
      
    if (count($qs)) {
      foreach ($qs as $n => $v) $qs[$n] = urlencode($n).'='.urlencode($v);
      $qs = join('&', $qs);
      $values['body'] = preg_replace('/(<a[^>]+href=")([^"]*)/emi', '"\\1"._send_qs("\2","'.$qs.'")', $body);
    }
    else {
      $values['body'] = $body;
    }
    
    // call the delivery callback
    $ret = (($count = call_user_func($deliver, $sender, $r, $values)) !== false ) 
      && $ret;

    // log the recipient if there are no nodes in the message
    if (!count($values['nids'])) {
      db_query("INSERT INTO {send_recipient} 
          ( sid ,nid ,rid ,rtype  ,mail, name, rcount ) 
          VALUES ( %d ,%d ,%d ,'%s', '%s', '%s', %d )",
        $sid, 0, $rid, $rtype, $r_mail, $r_name, $count );
    }
    // log each node/user combination 
    foreach ($values['nids'] as $nid) {
      db_query("INSERT INTO {send_recipient} 
          ( sid ,nid ,rid ,rtype  ,mail, name, rcount ) 
          VALUES ( %d ,%d ,%d ,'%s', '%s', '%s', %d )",
        $sid, $nid, $rid, $rtype, $r_mail, $r_name, $count );
    }
    
  }
  if ($ret) {
    flood_register_event("send $module");
        
    if ($values['sender_cc']) {
      $self = $user->uid ? $user : $sender; //if it's a registered user, use their "real" address

      mimemail($sender, $self, $subject, $body);
      drupal_set_message(t('A copy of this message has also been sent to %mail',array('%mail'=>$values['sender_mail'])));
    }
  }
  
  // get confirmation callback
  if($callback = module_invoke($module, 'send', 'confirm', $module)) {
    return call_user_func($callback, $values);
  }
  return _send_confirm($values);
}
      
function _send_deliver($sender, $recipient, $values) {
  if (mimemail($sender, $recipient, $values['subject'], $values['body'])) {
    drupal_set_message(t('Message sent to %mail',array('%mail'=>$recipient['mail'])));
  }
  // return the count of recipients
  if (is_object($recipient) || isset($recipient['mail'])) return 1;
  return count($recipient);
}

function _send_confirm($values) {
  if (count($nids = $values['nids']) == 1) {
    drupal_goto('node/'.$nids[0]);
  }
  
  $out = '<h2>'.$values['subject'].'</h2>';
  $out .= $body;
  echo theme('page',$out);
  exit;
}

/**
 * build the body text
 */
function _send_body($message, $nids, $module, $mode) {
  $modules = _send_modules();
  
  $body = '';
  
  foreach($nids as $nid) { 
    $node = node_load($nid);
    switch ($mode) {
      
      case 'title' :
        $body .= $node->title.'<br />';
        break;
        
      case 'teaser' :
        $text = node_view($node, true, false, false);
        $body .= _send_hook_modify($text, 'node', $module, $node->type, $node);
        break;
        
      case 'body' :
        $text = node_view($node, false, false, false);
        $body .= _send_hook_modify($text, 'node', $module, $node->type, $node);
        break;
    }
  }
  
  // let modules prepend / append stuff to the body, or otherwise modify it
  $body = _send_hook_modify($body, 'node', $module, $node->type, $node);
  return $body;
}

// callback for querystring preg
function _send_qs($url, $qs) {
  return $url . (strpos($url, '?') !== false ? '&' : '?') . $qs;
}

function _send_hook_modify($text, $op, $module, $nodetype='', $node=null) {
  $modules = _send_modules();
  foreach ($modules as $m) {
    $callback = module_invoke($m, 'send', $op, $nodetype, $node);
    if ($callback && !is_null($altered = call_user_func($callback, $text))) {
      $text = $altered;
    }
  }
  return $text;
}

/**
 * load and/or update contact info in CiviCRM
 * 
 * $params can contain name/value pairs for civicrm's data fields, optionally
 * prepended by "{$scope}_".  The contact record will be created and/or filled
 * with the data from $params, and $params will similarly be filled with CRM data
 * for use by the rest of this module.
 */
function _send_crm_contact($mail, &$params, $user=null, $scope='') {
  if (!module_exist('civicrm')) return false;
  if ($scope) $scope .= '_';
  
  civicrm_initialize(true);
  
  // fields allowed in the contact record
  $contact_fields = array('first_name', 'last_name', 'email', 'source', 'prefix', 'suffix',
    'display_name', 'legal_identifier', 'external_identifier', 'job_title', 'gender', 
    'birth_date', 'is_deceased', 'preferred_communication_method', 'do_not_phone', 
    'do_not_email', 'do_not_mail', 'home_URL', 'image_URL', 'street_address' );
  
  // create an array of CRM data from $params.  Strip out the part of 
  // the variable that conveys scope (sender_ , recipient_) if you have to
  $record = array();
  foreach ($params as $key => $value) {
    if (!in_array($name = str_replace($scope, '', $key), $contact_fields)) continue;
    $record[$name] = $params[$key];
  }
  
  // find contact
  $search = array();
  if ($user && $id = crm_uf_get_match_id($user->uid)) {
    $search['id'] = $id;
  }
  elseif ($mail) {
    $search['email'] = $mail;
  }
  else {
    return;                      // we don't have enough to work with here
  }
  if ($res = crm_contact_search($search)) $contact = current($res[0]);
  
  if($contact['contact_id']) {
    $updates = array();
    foreach ($record as $key => $value) {
      // populate contact info if it's not there already
      if (!isset($contact[$key]) && $value) {
        $updates[$key] = $value;
      }
      // update our referenced array with CRM info
      else {
        $record[$key] = $contact[$key];
      }
    }
    $contact = crm_get_contact($contact);
    
    if (count($updates)) {
      $contact = crm_update_contact($contact, $updates);
    }
  }
  else {
    // no contact.  let's create one
    $contact = array_merge(array('email' => $mail), $record);
    $contact = crm_create_contact($contact);
  }
  
  // save data to the referenced $params array if it's not already set 
  foreach ($record as $key => $value) {
    if (!$params[$scope.$key])$params[$scope.$key] = $value;
  }

  return $contact;
}

function _send_query($query, $module, $limit, $ts_from, $ts_to, $params) {
  $ts_from = (int) $ts_from;
  $ts_to = $ts_to ? (int) $ts_to : time();
  
  switch ($query) {
    case 'nodes':
      $res = db_query(db_rewrite_sql('SELECT n.nid, n.title, COUNT(*) AS count 
        FROM {node} n, {send_recipient} s WHERE s.nid = n.nid
        GROUP BY  n.nid, n.title  ORDER BY count DESC LIMIT %d',$limit));
      break;
    
    case 'users':
      $res = db_query('SELECT u.uid, u.name, u.mail, COUNT(1) AS count 
        FROM {user} u LEFT JOIN {send} s WHERE n.uid = s.uid
        GROUP BY u.uid, u.name, u.mail
        ORDER BY count DESC LIMIT %d',$limit);
      break;
  }
  
  if (!$res) return;
  
  $items = array();
  while ($row = db_fetch_object($res)) {
    $items[] = $row;
  }
  return $items;
}


function _send_previous_recipients($user) {
  $recipients = array();
  
  $res = db_query('SELECT r.mail, r.name, MAX(s.timestamp)
      FROM {send} s RIGHT JOIN {send_recipient} r ON r.sid = s.sid
      WHERE s.uid = %d GROUP BY r.mail, r.name, s.timestamp 
      ORDER BY r.mail, s.timestamp ASC',$user->uid);
      
  while ($row = db_fetch_object($res)) {
    $recipients[] = Array('mail' => $row->mail, 
      'name' => $row->name,
    );
  }
  return $recipients;
}

function theme_send_form(&$form) {
  $from    = form_render($form['from']);
  $to      = form_render($form['to']);
  $buttons = form_render($form['buttons']);
  $subject = form_render($form['subject']);
  $message = form_render($form['message']);
  $template= form_render($form['template']);
  $body    = form_render($form['body']);
  $extra   = form_render($form);
  
  $replace = array('%message', '%body');
  $values  = array($message, $body);
  $content = str_replace($replace, $values, $template);
  
  $headers = theme('table', array(t('From'),t('To')),array(array('data' => array($from, $to), 'valign' => 'top')),array('width'=>'100%'));
  
  return $headers.'<br clear="all" />'.$extra.$buttons.'<br clear="all" />'.$subject.'<br clear="all" />'.$content;
}

function theme_send_template() {
  $template = "%message\n%body\n";
  return $template;
}

function theme_send_body($values) {
  $body = '';
  $template .= $values['template'];
  if ($values['message']) {
    $message = '<div class="messages">'.check_markup($values['message']).'</div>';
  }
  $body = $values['node_body'];
  $replace = array('%message', '%body');
  $values  = array($message, $body);
  
  return str_replace($replace, $values, $template);
}
